<template>
  <b-card title="Authorization" class="mb-1">
    <b-form @submit.prevent="login()">
      <b-form-group>
        <b-form-input
            id="input-1"
            v-model="form.uid"
            placeholder="Login"
            required
        ></b-form-input>
      </b-form-group>
      <b-form-group>
        <b-form-input
            id="input-2"
            v-model="form.password"
            placeholder="Password"
            type="password"
            autocomplete="false"
            required
        ></b-form-input>
      </b-form-group>

      <b-button :disabled="disabled_submit" block type="submit">Login</b-button>
    </b-form>
  </b-card>
</template>

<script>


import router from "@/router";

export default {
  name: "Authorization",
  data() {
    return {
      form: {
        uid: '',
        password: '',
      },
      disabled_submit: false,
    }
  },
  methods: {

    login: function () {
      this.disabled_submit = true;
      this.$root.login(this.form.uid, this.form.password).then(response => {
        router.options.update_user_data(response.data);
        this.disabled_submit = false;
      }).catch(error => {
        this.disabled_submit = false;
        this.$root.make_notification(
            !error.response || error.response.status >= 500
                ? 'Something went wrong 🤷‍♀️'
                : error.response.data.reason,
            'Login failed')
        this.$emit('template_ready');
      });
    },

    template_ready: function () {
      this.$emit('template_ready');
      console.log('home ready');
    },
    template_load: function () {
      this.$emit('template_load');
    }
  }
}
</script>

<style scoped>

</style>